<?php
namespace com;
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK ]
// +----------------------------------------------------------------------
// | Copyright (c) 2006~2017 http://thinkphp.cn All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: zhangyajun <448901948@qq.com>
// +----------------------------------------------------------------------
use think\Paginator;
use think\Config;

class Page extends Paginator
{
	protected function upurl($url){
		if (config('sys.url_model') == 3) {
			$url = preg_replace('/page\/*\/[0-9]/','',$url);
            $url = str_replace([ "?", '='], ['', '/'], $url);
            if (!strstr($url, "/page/") && strstr($url, "/tag/") ) {
                if (isset($_GET['page']) >=10) {
                    $url = str_replace("/page/", "/page/", $url);
                }else{
                    $url = str_replace("page/", "/page/", $url);
                }
            }
		}
		return $url;
	}
    //首页
    protected function home() {
        if ($this->currentPage() > 1) {
            return "<li><a href='" . $this->upurl($this->url(1)) . "' title='首页'>首页</a></li>";
        } else {
            return "<li><a>首页</a></li>";
        }
    }
    //上一页
    protected function prev() {
        if ($this->currentPage() > 1) {
            return "<li><a href='" . $this->upurl($this->url($this->currentPage - 1)) . "' title='上一页'>上一页</a></li>";
        } else {
            return "<li><a>上一页</a></li>";
        }
    }
    //下一页
    protected function next() {
        if ($this->hasMore) {
            return "<li><a href='" . $this->upurl($this->url($this->currentPage + 1)) . "' title='下一页'>下一页</a></li>";
        } else {
            return"<li><a>下一页</a></li>";
        }
    }
    //尾页
    protected function last() {
        if ($this->hasMore) {
            return "<li><a href='" . $this->upurl($this->url($this->lastPage)) . "' title='尾页'>尾页</a></li>";
        } else {
            return "<li><a>尾页</a></li>";
        }
    }
    //统计信息
    protected function info(){
        return "<li><span class='pageRemark'>共" . $this->lastPage .
            "页" . $this->total . "条数据</span></li>";
    }
    /**
     * 页码按钮
     * @return string
     */
    protected function getLinks()
    {
        if ($this->simple)
            return '';
        $block = null;
        //生成指定数量的按钮 
        $rows   = $this->options['var_link_rows'] ? $this->options['var_link_rows'] : 5;        
        if ($this->lastPage <  $rows ) {
            $block = $this->getUrlRange(1, $this->lastPage);
        } else{          
             $side = intval($rows/2);
             $str  = $this->currentPage - $side;
             $str  = $str < 1? 1 : $str ;
             
             $end  = $str + $rows - 1;
             if($end > $this->lastPage){                 
                 $end = $this->lastPage;
                 $str = $end - $rows +1;
                 $str  = $str < 1? 1 : $str ;
             }
             $block= $this->getUrlRange($str,$end);            
        } 
        return  $this->getUrlLinks($block);
    }
   /* protected function getLinks()
    {
        $block = [
            'first'  => null,
            'slider' => null,
            'last'   => null
        ];
        $side   = 3;
        $window = $side * 2;
        if ($this->lastPage < $window + 6) {
            $block['first'] = $this->getUrlRange(1, $this->lastPage);
        } elseif ($this->currentPage <= $window) {
            $block['first'] = $this->getUrlRange(1, $window + 2);
            $block['last']  = $this->getUrlRange($this->lastPage - 1, $this->lastPage);
        } elseif ($this->currentPage > ($this->lastPage - $window)) {
            $block['first'] = $this->getUrlRange(1, 2);
            $block['last']  = $this->getUrlRange($this->lastPage - ($window + 2), $this->lastPage);
        } else {
            $block['first']  = $this->getUrlRange(1, 2);
            $block['slider'] = $this->getUrlRange($this->currentPage - $side, $this->currentPage + $side);
            $block['last']   = $this->getUrlRange($this->lastPage - 1, $this->lastPage);
        }
        $html = '';
        if (is_array($block['first'])) {
            $html .= $this->getUrlLinks($block['first']);
        }
        if (is_array($block['slider'])) {
            $html .= $this->getDots();
            $html .= $this->getUrlLinks($block['slider']);
        }
        if (is_array($block['last'])) {
            $html .= $this->getDots();
            $html .= $this->getUrlLinks($block['last']);
        }
        return $html;
    }*/

    /**
     * 渲染分页html
     * @return mixed
     */
    public function render()
    {
        if ($this->hasPages()) {
            if ($this->simple) {
                return sprintf(
                    '%s<div class="pagination">%s %s %s</div>',
                    $this->css(),
                    $this->prev(),
                    $this->getLinks(),
                    $this->next()
                );
            } else {
                return sprintf(
                    '%s<div class="pagination">%s %s %s %s %s %s</div>',
                    $this->css(),
                    $this->home(),
                    $this->prev(),
                    $this->getLinks(),
                    $this->next(),
                    $this->last(),
                    $this->info()
                );
            }
        }
    }
    /**
     * 生成一个可点击的按钮
     *
     * @param  string $url
     * @param  int    $page
     * @return string
     */
    protected function getAvailablePageWrapper($url, $page)
    {
        return '<li><a href="' . $this->upurl(htmlentities($url)) . '"  >' . $page . '</a></li>';
    }
    /**
     * 生成一个禁用的按钮
     *
     * @param  string $text
     * @return string
     */
    protected function getDisabledTextWrapper($text)
    {
        return '<li class="pageEllipsis">' . $text . '</li>';
    }
    /**
     * 生成一个激活的按钮
     *
     * @param  string $text
     * @return string
     */
    protected function getActivePageWrapper($text)
    {
        return '<li><a href="" class="cur">' . $text . '</a></li>';
    }
    /**
     * 生成省略号按钮
     *
     * @return string
     */
    protected function getDots()
    {
        return $this->getDisabledTextWrapper('...');
    }
    /**
     * 批量生成页码按钮.
     *
     * @param  array $urls
     * @return string
     */
    protected function getUrlLinks(array $urls)
    {
        $html = '';
        foreach ($urls as $page => $url) {
            $html .= $this->getPageLinkWrapper($url, $page);
        }
        return $html;
    }
    /**
     * 生成普通页码按钮
     *
     * @param  string $url
     * @param  int    $page
     * @return string
     */
    protected function getPageLinkWrapper($url, $page)
    {
        if ($page == $this->currentPage()) {
            return $this->getActivePageWrapper($page);
        }
        return $this->getAvailablePageWrapper($url, $page);
    }
    /**
     * 分页样式
     */
    protected function css(){
        return '<style type="text/css">
        .pagination li {display:inline-block;border-radius:5px;border:0}
        .pagination li a,.pagination li span {border-radius:5px;padding:9px 14px;display:block;margin:5px;}
        .pagination li span.pageRemark {background:none;}
        .pagination li.pageEllipsis {background:none;}
        </style>';
    }
}